const querySale = require('../model/sale');
const getMaxMinRows = require('../helpers/getMaxMinRows');

class SaleController {
  /**
   * @returns versão do monitoramento
   */
  varsao() {
    return '0.0.1';
  }

  /**
   * @param {*} req
   * @param {*} res
   * @returns Retorna as vendas com problema ou o id e vendas true para sem erros.
   */
  async getUnidades(req, res) {
    try {
      const { page = 1, limit = 10 } = req.query;
      const { minRow, maxRow } = getMaxMinRows(page, limit);

      const queryResultAll = await querySale.getAll({ MIN_ROW: minRow, MAX_ROW: maxRow });
      const { rows } = queryResultAll;
      if (!rows.length) {
        return res.status(400).json({ sales: [] });
      }
      const sales = rows.map((item) => {
        /**
         * Para retornar false ele deveria consultar o dataVenda > 1 minuto na tabela do slave
         * "DLV_" no campo DSCOMANDA.
        */
        let statusDelivery = false;
        if (item[2] !== null) {
          statusDelivery = false;
        } else {
          statusDelivery = true;
        }

        /**
         * Verificar Mesa
         * IDSINCMSDE = 'N', NRVENDARESTAUX = NULL.
         */

        /**
         * Verificar Comanda
         * IDSINCMSDE = 'N', NRVENDARESTAUX = NULL.
         */

        return {
          idFilial: item[0],
          dataVenda: item[1],
          nrComanda: item[2],
          dsComanda: item[3],
          nrVenda: item[4],
          idSincmsde: item[5],
          nrVedarestaux: item[6],
          delivery: statusDelivery,
        };
      });
      return sales;
    } catch (error) {
      return error;
    }
  }

  async salesSlave(vendasError) {
    const venda = [];
    /** Se não vier vendas, é porque não tem erro */
    if (vendasError.recordset !== undefined) {
      vendasError.recordset.forEach((element) => {
        venda.push({
          id: element.CDFILIAL,
          vendas: false,
          nvenda: element.NRSEQVENDA,
          cupom: element.CDOPERFECHCUPOM,
          nf: element.NRNOTAFISCALCE,
          message: '',
        });
      });
    } else if (vendasError.length > 0) {
      venda.push({
        id: vendasError[0].FILIAL,
        vendas: vendasError[0].vendas,
      });
    }
    return venda;
  }
}

module.exports = new SaleController();
